<?php

/**
 * @file
 * Default views for the metis module
 */

/**
 * Implements hook_views_default_views().
 */
function metis_views_default_views() {

  // Get metis field name(s).
  $fields = content_fields();
  $metis_fields = array();

  // Select metis fields.
  foreach ($fields as $field) {
    if ($field['type'] == 'metis') {
      $metis_fields[] = $field['field_name'];
    }
  }

  // Provide one view per Metis field.
  foreach ($metis_fields as $field) {

    $view = new view();
    $view->name = 'metis_' . $field;
    $view->description = 'A list of nodes and their respective metis codes for the field ' . $field;
    $view->tag = '';
    $view->base_table = 'node';
    $view->core = 6;
    $view->api_version = '2';
    $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */
    $handler = $view->new_display('default', 'Defaults', 'default');
    $handler->override_option('fields', array(
      'nid' => array(
        'label' => 'ID',
        'alter' => array(
          'alter_text' => 0,
          'text' => '',
          'make_link' => 0,
          'path' => '',
          'absolute' => 0,
          'link_class' => '',
          'alt' => '',
          'rel' => '',
          'prefix' => '',
          'suffix' => '',
          'target' => '',
          'help' => '',
          'trim' => 0,
          'max_length' => '',
          'word_boundary' => 1,
          'ellipsis' => 1,
          'html' => 0,
          'strip_tags' => 0,
        ),
        'empty' => '',
        'hide_empty' => 0,
        'empty_zero' => 0,
        'hide_alter_empty' => 1,
        'link_to_node' => 0,
        'exclude' => 0,
        'id' => 'nid',
        'table' => 'node',
        'field' => 'nid',
        'relationship' => 'none',
      ),
      'created' => array(
        'label' => 'Date',
        'alter' => array(
          'alter_text' => 0,
          'text' => '',
          'make_link' => 0,
          'path' => '',
          'absolute' => 0,
          'link_class' => '',
          'alt' => '',
          'rel' => '',
          'prefix' => '',
          'suffix' => '',
          'target' => '',
          'help' => '',
          'trim' => 0,
          'max_length' => '',
          'word_boundary' => 1,
          'ellipsis' => 1,
          'html' => 0,
          'strip_tags' => 0,
        ),
        'empty' => '',
        'hide_empty' => 0,
        'empty_zero' => 0,
        'hide_alter_empty' => 1,
        'date_format' => 'small',
        'custom_date_format' => '',
        'exclude' => 0,
        'id' => 'created',
        'table' => 'node',
        'field' => 'created',
        'relationship' => 'none',
      ),
      'title' => array(
        'label' => 'Title',
        'alter' => array(
          'alter_text' => 0,
          'text' => '',
          'make_link' => 0,
          'path' => '',
          'absolute' => 0,
          'link_class' => '',
          'alt' => '',
          'rel' => '',
          'prefix' => '',
          'suffix' => '',
          'target' => '',
          'help' => '',
          'trim' => 0,
          'max_length' => '',
          'word_boundary' => 1,
          'ellipsis' => 1,
          'html' => 0,
          'strip_tags' => 0,
        ),
        'empty' => '',
        'hide_empty' => 0,
        'empty_zero' => 0,
        'hide_alter_empty' => 1,
        'link_to_node' => 1,
        'exclude' => 0,
        'id' => 'title',
        'table' => 'node',
        'field' => 'title',
        'relationship' => 'none',
      ),
      'name' => array(
        'label' => 'Name',
        'alter' => array(
          'alter_text' => 0,
          'text' => '',
          'make_link' => 0,
          'path' => '',
          'absolute' => 0,
          'link_class' => '',
          'alt' => '',
          'rel' => '',
          'prefix' => '',
          'suffix' => '',
          'target' => '',
          'help' => '',
          'trim' => 0,
          'max_length' => '',
          'word_boundary' => 1,
          'ellipsis' => 1,
          'html' => 0,
          'strip_tags' => 0,
        ),
        'empty' => '',
        'hide_empty' => 0,
        'empty_zero' => 0,
        'hide_alter_empty' => 1,
        'link_to_user' => 1,
        'overwrite_anonymous' => 0,
        'anonymous_text' => '',
        'exclude' => 0,
        'id' => 'name',
        'table' => 'users',
        'field' => 'name',
        'relationship' => 'none',
      ),
      $field . '_code_public' => array(
        'label' => 'Metis codes',
        'alter' => array(
          'alter_text' => 0,
          'text' => '',
          'make_link' => 0,
          'path' => '',
          'absolute' => 0,
          'link_class' => '',
          'alt' => '',
          'rel' => '',
          'prefix' => '',
          'suffix' => '',
          'target' => '',
          'help' => '',
          'trim' => 0,
          'max_length' => '',
          'word_boundary' => 1,
          'ellipsis' => 1,
          'html' => 0,
          'strip_tags' => 0,
        ),
        'empty' => '',
        'hide_empty' => 0,
        'empty_zero' => 0,
        'hide_alter_empty' => 1,
        'link_to_node' => 0,
        'label_type' => 'custom',
        'format' => 'codes',
        'multiple' => array(
          'group' => TRUE,
          'multiple_number' => '',
          'multiple_from' => '',
          'multiple_reversed' => FALSE,
        ),
        'exclude' => 0,
        'id' => $field . '_code_public',
        'table' => 'node_data_' . $field,
        'field' => $field . '_code_public',
        'relationship' => 'none',
      ),
      $field . '_code_public_1' => array(
        'label' => 'Show',
        'alter' => array(
          'alter_text' => 0,
          'text' => '',
          'make_link' => 0,
          'path' => '',
          'absolute' => 0,
          'link_class' => '',
          'alt' => '',
          'rel' => '',
          'prefix' => '',
          'suffix' => '',
          'target' => '',
          'help' => '',
          'trim' => 0,
          'max_length' => '',
          'word_boundary' => 1,
          'ellipsis' => 1,
          'html' => 0,
          'strip_tags' => 0,
        ),
        'empty' => '',
        'hide_empty' => 0,
        'empty_zero' => 0,
        'hide_alter_empty' => 1,
        'link_to_node' => 0,
        'label_type' => 'custom',
        'format' => 'show',
        'multiple' => array(
          'group' => TRUE,
          'multiple_number' => '',
          'multiple_from' => '',
          'multiple_reversed' => FALSE,
        ),
        'exclude' => 0,
        'id' => $field . '_code_public_1',
        'table' => 'node_data_' . $field,
        'field' => $field . '_code_public',
        'relationship' => 'none',
      ),
    ));
    $handler->override_option('filters', array(
      $field . '_code_public' => array(
        'operator' => 'not empty',
        'value' => '',
        'group' => '0',
        'exposed' => FALSE,
        'expose' => array(
          'operator' => FALSE,
          'label' => '',
          'optional' => FALSE,
        ),
        'case' => 1,
        'id' => $field . '_code_public',
        'table' => 'node_data_' . $field,
        'field' => $field . '_code_public',
        'relationship' => 'none',
      ),
    ));
    $handler->override_option('access', array(
      'type' => 'perm',
      'perm' => 'administer metis module',
    ));
    $handler->override_option('cache', array(
      'type' => 'none',
    ));
    $handler->override_option('title', 'Overview of metis code\'s usage');
    $handler->override_option('use_ajax', TRUE);
    $handler->override_option('items_per_page', 30);
    $handler->override_option('use_pager', '1');
    $handler->override_option('distinct', 1);
    $handler->override_option('style_plugin', 'table');
    $handler->override_option('style_options', array(
      'grouping' => '',
      'override' => 1,
      'sticky' => 1,
      'order' => 'desc',
      'summary' => '',
      'columns' => array(
        'nid' => 'nid',
        'created' => 'created',
        'title' => 'title',
        $field . '_code_public_2' => $field . '_code_public_2',
        $field . '_code_public' => $field . '_code_public_2',
        $field . '_code_public_1' => $field . '_code_public_1',
      ),
      'info' => array(
        'nid' => array(
          'sortable' => 1,
          'separator' => '',
        ),
        'created' => array(
          'sortable' => 1,
          'separator' => '',
        ),
        'title' => array(
          'sortable' => 1,
          'separator' => '',
        ),
        $field . '_code_public_2' => array(
          'sortable' => 1,
          'separator' => '<br />',
        ),
        $field . '_code_public' => array(
          'sortable' => 1,
          'separator' => '',
        ),
        $field . '_code_public_1' => array(
          'sortable' => 1,
          'separator' => '',
        ),
      ),
      'default' => 'nid',
    ));

    $views[$view->name] = $view;

  }

  return $views;

}
